'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTimezone = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

var _lodash = require('lodash.sortby');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

require('moment-timezone');

require('react-select/dist/react-select.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var formatTimezone = exports.formatTimezone = function formatTimezone(tzString) {
  return '(GMT' + _moment2.default.tz(tzString).format('Z') + ') ' + tzString;
};

var SelectTimezone = function (_React$Component) {
  _inherits(SelectTimezone, _React$Component);

  function SelectTimezone(props) {
    _classCallCheck(this, SelectTimezone);

    var _this = _possibleConstructorReturn(this, (SelectTimezone.__proto__ || Object.getPrototypeOf(SelectTimezone)).call(this, props));

    _this.state = {};
    if (props.guess) {
      _this.state.selectedValue = _moment2.default.tz.guess();
    }
    return _this;
  }

  _createClass(SelectTimezone, [{
    key: 'timeZones',
    value: function timeZones() {
      var timeZones = _moment2.default.tz.names();
      var offsetTmz = [];

      for (var i in timeZones) {
        var tz = _moment2.default.tz(timeZones[i]);
        var tzStringOffset = tz.format('Z').replace(':00', '').replace(':30', '.5');
        var x = tzStringOffset === 0 ? 0 : parseInt(tzStringOffset).toFixed(2);

        var timeZone = {
          label: formatTimezone(timeZones[i]),
          value: '' + timeZones[i],
          time: '' + x,
          offset: tz._offset
        };
        offsetTmz.push(timeZone);
      }

      return (0, _lodash2.default)(offsetTmz, [function (el) {
        return -el.time;
      }]);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _onChange = _props.onChange,
          value = _props.value,
          _props$clearable = _props.clearable,
          clearable = _props$clearable === undefined ? false : _props$clearable,
          restProps = _objectWithoutProperties(_props, ['onChange', 'value', 'clearable']);

      var selectOptions = this.timeZones();
      return _react2.default.createElement(_reactSelect2.default, _extends({
        clearable: clearable,
        options: selectOptions,
        onChange: function onChange(val) {
          if (val) {
            _this2.setState({ selectedValue: val.value });
            _onChange && _onChange(val);
          } else {
            _this2.setState({ selectedValue: null });
            _onChange && _onChange({ value: null });
          }
        },
        value: this.state.selectedValue
      }, restProps));
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.value) {
        return {
          selectedValue: nextProps.value
        };
      }
      if (nextProps.value === undefined) {
        return prevState;
      }
      return {
        selectedValue: null
      };
    }
  }]);

  return SelectTimezone;
}(_react2.default.Component);

exports.default = SelectTimezone;